
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>KMP与扩展KMP / 憋错料</title>

    <meta name="description" content="KMP与扩展KMP 原文转自:http://www.cppblog.com/MatoNo1/archive/2011/04/17/144390.aspx KMP:给出两个字符串A(称为模板串)和B(称为子串),长度分别为lenA和lenB,要求在线性时间内,对于每个A[i] (0&lt;=i&lt;lenA),求出A[i]往前和B的前缀匹配的最大匹配长度,记为ex[i](或者说,ex[i]为满足A[i- z+1..i]==B[0..z-1]的最大的z值).KMP的主要目的是求B是不是A的子串,以及若是,B在A中所有 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">KMP与扩展KMP</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>原文转自：<a href="http://www.cppblog.com/MatoNo1/archive/2011/04/17/144390.aspx" rel="external nofollow noreferrer">http://www.cppblog.com/MatoNo1/archive/2011/04/17/144390.aspx</a></p>
<p>KMP：给出两个字符串A（称为模板串）和B（称为子串），长度分别为lenA和lenB，要求在线性时间内，对于每个A[i] （0&lt;=i&lt;lenA)，求出A[i]往前和B的前缀匹配的最大匹配长度，记为ex[i]（或者说，ex[i]为满足A[i- z+1..i]==B[0..z-1]的最大的z值）。KMP的主要目的是求B是不是A的子串，以及若是，B在A中所有出现的位置（当 ex[i]=lenB时）。<br />【算法】<br />设next[i]为满足B[i-z+1..i]==B[0..z-1]的最大的z值（也就是B的自身匹配）。设目前next[0..lenB-1]与ex[0..i-1]均已求出，要用它们来求ex[i]的值。<br />根<br />
据ex的定义，有A[i-1-ex[i-1]+1..i-1]==B[0..ex[i-1]-1]，这时，若有A[i]==B[ex[i-1]]，则可以<br />
直接得到ex[i]=ex[i-1]+1（因为i-1-ex[i-1]+1即i-ex[i-1]，现在由于A[i]==B[ex[i-1]]，可得<br />
A[i-ex[i-1]..i]==B[0..ex[i-1]]，即A[i-ex[i-1]+1-1..i]==B[0..ex[i-1]+1-1]，所<br />
以ex[i]=ex[i-1]+1）。若A[i]!=B[ex[i-1]]？<br />设j=next[ex[i-1]-1]，<br />
则根据next定义得B[ex[i-1]-j..ex[i-1]-1]==B[0..j-1]，又因为A[i-ex[i-1]..i-<br />
1]==B[0..ex[i-1]-1]得A[i-j..i-1]==B[ex[i-1]-j..ex[i-1]-1]，这样有<strong>A[i-j..i-1]==B[0..j-1]</strong>！<br />
也就是此时只需再比较A[i]与B[j]的值是否相等即可，若相等，可得ex[i]=j+1，若仍不相等，则更新j为next[j-1]，继续比较<br />
A[i]与B[j]是否相等&hellip;&hellip;直到A[i]与B[j]相等或直到j==0时，A[i]仍不等于B[j]，此时ex[i]=0。边界：求ex[0]时，初<br />
始j（用来代替ex[i-1]）为0。<br />现在还有一个问题，如何求next？显然next就是以B自身为模板串，B为子串的&ldquo;自身匹配&rdquo;，用类似的办法即可，唯一不同的是next[0]=lenB可以直接得到，求next[1]时，初始j（代替next[i-1]）为0。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1     lenA = strlen(A); lenB = strlen(B);
 2     next[0] = lenB;
 3     int j = 0;
 4     re2(i, 1, lenB) {
 5         while (j &amp;&amp; B[i] != B[j]) j = next[j - 1];
 6         if (B[i] == B[j]) j++;
 7         next[i] = j;
 8     }
 9     j = 0;
10     re(i, lenA) {
11         while (j &amp;&amp; A[i] != B[j]) j = next[j - 1];
12         if (A[i] == B[j]) j++;
13         ex[i] = j;
14     }</pre>
<p>核心代码</p>
<p>扩展KMP：给出模板串A和子串B，长度分别为lenA和lenB，要求在线性时间内，对于每个A[i]（0&lt;=i&lt; lenA)，求出A[i..lenA-1]与B的最长公共前缀长度，记为ex[i]（或者说，ex[i]为满足A[i..i+z-1]==B[0..z- 1]的最大的z值）。扩展KMP可以用来解决很多字符串问题，如求一个字符串的最长回文子串和最长重复子串。<br />【算法】<br />设next[i]为满足B[i..i+z-1]==B[0..z-1]的最大的z值（也就是B的自身匹配）。设目前next[0..lenB-1]与ex[0..i-1]均已求出，要用它们来求ex[i]的值。<br />设<br />
p为目前A串中匹配到的最远位置，k为让其匹配到最远位置的值（或者说，k是在0&lt;=i0&lt;i的所有i0值中，使i0+ex[i0]-1的值<br />
最大的一个，p为这个最大值，即k+ex[k]-1），显然，p之后的所有位都是未知的，也就是目前还无法知道A[p+1..lenA-1]中的任何一位<br />
和B的任何一位是否相等。<br />根据ex的定义可得，A[k..p]==B[0..p-k]，因为i&gt;k，所以又有<br />
A[i..p]==B[i-k..p-k]，设L=next[i-k]，则根据next的定义有B[0..L-1]==B[i-k..i-k+L-1]。<br />
考虑i-k+L-1与p-k的关系：<br />（1）i-k+L-1&lt;p-k，即i+L&lt;=p。这时，由<br />
A[i..p]==B[i-k..p-k]可以得到A[i..i+L-1]==B[i-k..i-k+L-1]，又因为B[0..L-1]==B[i-<br />
k..i-k+L-1]所以A[i..i+L-1]==B[0..L-1]，这就说明ex[i]&gt;=L。又由于next的定义可得，A[i+L]必<br />
然不等于B[L]（否则A[i..i+L]==B[0..L]，因为i+L&lt;=p，所以A[i..i+L]==B[i-k..i-k+L]，这样<br />
B[0..L]==B[i-k..i-k+L]，故next[i-k]的值应为L+1或更大），这样，<strong>可以直接得到ex[i]=L！</strong><br />（2）i+k-<br />
L+1&gt;=p-k，即i+L&gt;p。这时，首先可以知道A[i..p]和B[0..p-i]是相等的（因为A[i..p]==B[i-<br />
k..p-k]，而i+k-L+1&gt;=p-k，由B[0..L-1]==B[i-k..i-k+L-1]可得B[0..p-i]==B[i-<br />
k..p-k]，即A[i..p]==B[0..p-i]），然后，对于A[p+1]和B[p-i+1]是否相等，目前是不知道的（因为前面已经说过，p<br />
是目前A串中匹配到的最远位置，在p之后无法知道任何一位的匹配信息），因此，要从A[p+1]与B[p-i+1]开始往后继续匹配（设j为目前B的匹配<br />
位置的下标，一开始j=p-i+1，每次比较A[i+j]与B[j]是否相等，直到不相等或者越界为止，此时的j值就是ex[i]的值）。在这种情况<br />
下，p的值必然会得到延伸，因此更新k和p的值。<br />边界：ex[0]的值需要预先求出，然后将初始的k设为0，p设为ex[0]-1。<br />对于求next数组，也是&ldquo;自身匹配&rdquo;，类似KMP的方法处理即可。唯一的不同点也在边界上：可以直接知道next[0]=lenB，next[1]的值预先求出，然后初始k=1，p=ex[1]。</p>
<p><strong>需<br />
要严重注意的是，在上述的情况（2）中，本该从A[p+1]与B[p-i+1]开始匹配，但是，若p+1&lt;i，也就是p-i+1&lt;0（这种情<br />
况是有可能发生的，当ex[i-1]=0，且前面的ex值都没有延伸到i及以后的时候）的话，需要将A、B的下标都加1（因为此时p必然等于i-2，如果<br />
A、B的下标用两个变量x、y控制的话，x和y都要加1）！！</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1 lenA = strlen(A); lenB = strlen(B);
 2     next[0] = lenB; next[1] = lenB - 1;
 3     re(i, lenB-1) if (B[i] != B[i + 1]) {next[1] = i; break;}
 4     int j, k = 1, p, L;
 5     re2(i, 2, lenB) {
 6         p = k + next[k] - 1; L = next[i - k];
 7         if (i + L &lt;= p) next[i] = L; else {
 8             j = p - i + 1;
 9             if (j &lt; 0) j = 0;
10             while (i + j &lt; lenB &amp;&amp; B[i + j] == B[j]) j++;
11             next[i] = j; k = i;
12         }
13     }
14     int minlen = lenA &lt;= lenB ? lenA : lenB; ex[0] = minlen;
15     re(i, minlen) if (A[i] != B[i]) {ex[0] = i; break;}
16     k = 0;
17     re2(i, 1, lenA) {
18         p = k + ex[k] - 1; L = next[i - k];
19         if (i + L &lt;= p) ex[i] = L; else {
20             j = p - i + 1;
21             if (j &lt; 0) j = 0;
22             while (i + j &lt; lenA &amp;&amp; j &lt; lenB &amp;&amp; A[i + j] == B[j]) j++;
23             ex[i] = j; k = i;
24         }
25     }</pre>
<p>核心代码</p>
<p>【时间复杂度分析】<br />在KMP和扩展KMP中，不管是A串还是B串，其匹配位置都是单调递增的，故总时间复杂度是线性的，都为O(lenA + lenB)（只是扩展KMP比KMP的常数更大一些）。<br />【应用】<br />KMP和扩展KMP在解决字符串问题中有大用。很多看上去很猥琐的字符串问题，都可以归结到这两种算法之中。另外，这里的&ldquo;字符串&rdquo;可以延伸为一切类型的数组，而不仅仅是字符数组。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-01 07:22:15 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>KMP与扩展KMP的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35l2YV0.html" rel="bookmark">KMP和扩展KMP【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这种东西基本上在纸上自己推导一下就能做出来XD 转发注明出处 KMP:给出两个字符串A(称为模板串)和B(称为子串),长度分别为lenA和lenB,要求在线性时间内,对于每个A[i] (0&lt;=i&lt;lenA),求出A[i]往前和B的前缀匹配的最大匹配长度,记为ex[i](或者说,ex[i]为满足A[i- z+1..i]==B[0..z-1]的最大的z值).KMP的主要目的是求B是不是A的子串,以及若是,B在A中所有出现的位置(当 ex[i]=lenB时).[算法]设next[i]为满足B[i-z			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41e67P4.html" rel="bookmark">KMP与扩展KMP初探</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				KMP KMP算法主要用于字符串匹配中的单串匹配 next函数:表示当前字符失配时,应从模式串的第几位开始匹配(越大越好).即模式串的前缀与以t[i]为结尾的后缀的最长相同部分的长度. 代码如下(pascal) var s,t:string; next,ans:array[0..100] of longint; i,j:longint; begin readln(s); readln(t); next[1]:=0; {构造next} j:=0; for i:=2 to length(t) do			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KjKr9M.html" rel="bookmark">KMP、扩展KMP、Manacher模板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				推导过程推荐看这篇: KMP模板: 1 void init(){ 2 int j = nex[0] = -1, i = 0; 3 int len = strlen(str); 4 while(i &lt; len){ 5 if(j == -1 || str[i] == str[j]){ 6 nex[++i] = ++j; 7 }else j = nex[j]; 8 } 9 } 10 int KMP(){ 11 int i = 0, j = 0, sum = 0; 12 int len = strlen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0x6gdB4.html" rel="bookmark">KMP、扩展KMP、MANACHER</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.KMP 作用:用于在一个文本串S内查找一个模式串P出现的位置 string str = &quot;bacbababadababacambabacaddababacasdsd&quot;; string ptr = &quot;ababaca&quot;; 如上图,可得在第10与26处包含ptr数组: 暴力做法:暴力for,碰到不一样的直接返回,从后一个开始继续for,最差能到O(n * m) KMP 做法: 主要的思路是跳,比如你一开始从上面例子里的bacbababadababacambabacad			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPgpNP4.html" rel="bookmark">字符串专题一：KMP与扩展KMP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				KMP算法主要用于解决单模式串的匹配问题,即:给定主串s和模式串p,问p是否是s的子串(len(s)&lt;=N, len(p)&lt;=M). 先考虑最朴素的算法,即枚举s中的起点i,检查s[i..i+M-1]是否等于p,这样的时间复杂度为O(NM). 分析一下为什么这样的算法效率低(建议读者手动画个图):设指针i和j分别指向s和p中的字符,不妨假定s[0..k-1]和p[0..k-1]已经匹配上了,而s[k]!=p[k](k&lt;M),这说明s[0..M-1]已经不能匹配上p了,根据朴素算法,指针i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47qgWY0.html" rel="bookmark">HDU 4333 Revolving Digits 扩展KMP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				链接:http://acm.hdu.edu.cn/showproblem.php?pid=4333 题意:给以数字字符串,移动最后若干位到最前边,统计得到的数字有多少比原来大,有多少和原来相同,有多少比原来的小. 思路:拓展KMP中的next数组标记的是子串和母串的公共前缀的长度,要将字符串长度变成原来二倍,这样如果变换后不是完全相同的数字也即公共前缀长度大于等于字符串长度,那么字母串公共前缀的下一位的大小比较就是题目所要求的比较.由于相同的数字串只算一次,则只要统计比较第一个&quot;循环节&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBRWqEM.html" rel="bookmark">扩展KMP复习小记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 KMP大家都耳熟能详,扩展KMP只是一个扩展版而已,字面意思啦! 我记得以前打过这个复习小记的,但是不知为何失踪了. KMP与扩展KMP的对比 KMP的next[i]表示从1到i的字符串s,前缀和后缀的最长重叠长度. EXKMP的next[i]表示从1到i的字符串s,和从i到n的字符串st的最长重叠长度. 也就是说KMP是向前的匹配,EXKMP是向后匹配. 扩展KMP问题是KMP问题的补充和加难. 具体内容 重要数组 给定母串S,和子串T.定义n=|S|, m=|T|. extend[i]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzyBz24.html" rel="bookmark">【扩展kmp&plus;最小循环节】HDU 4333 Revolving Digits</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://acm.hdu.edu.cn/showproblem.php?pid=4333 [题意] 给定一个数字&lt;=10^100000,每次将该数的第一位放到放到最后一位,求所有组成的不同的数比原数小的个数,相等的个数,大的个数 [思路] 这个数很大,用字符串处理 比较两个字符串的大小,一位一位很耗时,可以求出最长公共前缀,只比较最长公共前缀后一位 每次将数的最后一位放到最后一位,如abcd变成dabc,cdab,bcda,相当于abcdabcd各个后缀的前四位 这样就变成了求abcdabc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mzr1AdM.html" rel="bookmark">acdream1116 Gao the string&excl;&lpar;扩展KMP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天是字符串填坑的一天,首先填的第一个坑是扩展KMP.总结一下KMP和扩展KMP的区别. 在这里s是主串,t是模式串. KMP可以求出的是以s[i]为结尾的串和 t前缀匹配的最长的长度.假如这个长度是L的话,则: s[i-L+1...i]=t[0...L] 而所谓的失配指针f[i]指的就是当前i点失配时要匹配的长度,实际是用t文本串去匹配t. 扩展KMP则是以s[i]为起始的串和 t前缀匹配的最长的长度. 假如这个长度的话,则: s[i..i+L-1]=t[0...L] 扩展KMP里的nxt数组			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kMLG7v4.html" rel="bookmark" class="title">多线程 自定义消息 文件查找器  使窗口变灰</a>
					<div>
						bbs.176ku.com免费看 来自为知笔记(Wiz)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dgxgrM.html" rel="bookmark" class="title">求20个整数之和</a>
					<div>
						输入代码: /* *Copyright (c)2014烟台大学计算机与控制project学院 *All rights reserved. *文件名:sum.cpp *作 者:林海云 *完毕日期:201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pe5YoM.html" rel="bookmark" class="title">Android热修复学习之旅&mdash;&mdash;HotFix完全解析</a>
					<div>
						在上一篇博客Android热修复学习之旅开篇--热修复概述中,简单介绍了各个热修复框架的原理,本篇博客我将详细分析QQ空间热修复方案. Android dex分包原理介绍 QQ空间热修复方案基于And ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyK56e3.html" rel="bookmark" class="title">浅谈JavaScript词法分析步骤</a>
					<div>
						JavaScript代码运行前有一个类似编译的过程即词法分析,词法分析主要有三个步骤: 分析参数 再分析变量的声明 分析函数声明 具体步骤如下: 函数在运行的瞬间,生成一个活动对象(Active Ob ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35q17R3.html" rel="bookmark" class="title">IDEA 常见文件类型的图标介绍</a>
					<div>
						官网地址:http://www.jetbrains.com/idea/webhelp/symbols.html        对于各个图标,上图的 Description 写得非常详细,但是有几个还是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qv25p4.html" rel="bookmark" class="title">Web3D编程总结&mdash;&mdash;3D碰撞检测初探</a>
					<div>
						自己动手写一个方法比分析他人的写的方法困难很多,由此而来的对程序的进一步理解也是分析别人的代码很难得到的. 一.先来几张效果图: 1.场景中有两个半径为1的球体,蓝色线段从球心出发指向球体的“正向”  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqWQ63.html" rel="bookmark" class="title">java连接数据库&mdash;&mdash;JDBC连接数据库</a>
					<div>
						DBUtil.java   // 数据库操作文件 package com.bjpowernode.jdbc.util; import java.io.File; import java.io.File ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QwEQl0.html" rel="bookmark" class="title">2015元旦第一篇博文：Red5流媒体服务器搭建</a>
					<div>
						今天是2015年的第一天,白天陪老婆孩子去BHG(华联)转了转,中午在九毛九吃了顿午饭,就这样过了元旦,虽然有点累,但是挺开心,北京今天的天气也比较给力,风和日丽,没有雾霾!现在是晚上十点,因为白天出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymDjeM.html" rel="bookmark" class="title">ASP&period;NET 实现上传EXCEL，利用NOPI操作，转换得到DataTable</a>
					<div>
						这几天正好用到上传Excel,并根据Excel中的数据做相应的处理,故整理以备用. 用到的资源: (1)NOPI 2.2.0.0 可自己官网下载,也可点击:http://pan.baidu.com/s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzjX93.html" rel="bookmark" class="title">自定义指令的参数</a>
					<div>
						指令无外乎增强了 HTML,提供额外的功能 以上的指令基本上已经可以满足我们的绝大多数需要了 少数情况下我们有一些特殊的需要,可以通过自定义指令的方式实现. 从更高的层次上说,指令是DOM元素上的一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jeZ8DM.html" rel="bookmark" class="title">Intent属性详解一 component属性</a>
					<div>
						先看效果图 概述 在介绍Component之前,我们首先来了解ComponentName这个类:ComponentName与Intent同位于android.content包下,我们从Android官 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEr8d4.html" rel="bookmark" class="title">Number&lpar;&rpar;、parseInt&lpar;&rpar;、parseFloat&lpar;&rpar;的区别</a>
					<div>
						最近在一个项目中遇到:需要在前台页面用javascript去处理很数值的计算. 各种用法都有,为了统一且保证处理方式正确,特地总结了一下相关的数值转换的用法: 作用: Number():可以用于任何数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471JrR0.html" rel="bookmark" class="title">3&period;1&period;Purchasing</a>
					<div>
						采购的主要责任,是将供应商的产品和服务提供给你的公司.该任务需要下面的活动: 再操作计划中,明确物料需求 执行采购需求,采购询价和采购订单 发送物料到达和采购合同 1.采购的业务流程 在我们详细介绍之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNJKzM.html" rel="bookmark" class="title">MySQL备份恢复工具xtrabackup</a>
					<div>
						1.简介 XtraBackup是Percona提供的一个开源的.免费的MySQL数据库备份工具,它能够对InnoDB和XtraDB数据库进行热备份,据官方介绍,XtraBackup具有以下特点: 1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Ny9vZ3.html" rel="bookmark" class="title">Android IOS WebRTC 音视频开发总结（十八）</a>
					<div>
						本文主要介绍上次碰到的某些机器上看不到视频的问题,文章来自博客园RTC.Blacker,转载请说明出处. 之前做的视频聊天App一直运行良好,前几天客户反馈说在三星9100. Android4.0.3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47XD89M.html" rel="bookmark" class="title">14&period;1节：InnoDB简介</a>
					<div>
						14.1.1. InnoDB-MySQL默认的存储引擎 14.1.2. 检测InnoDB的可用性 14.1.3. 关闭InnoDB InnoDB是一个兼顾高可靠性和高性能的通用存储引擎.在MySQL5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9R9w0.html" rel="bookmark" class="title">惊！用arm-linux-gcc&period;4&period;3&period;2交叉编译器编译linux-3&period;0&period;1内核</a>
					<div>
						1.我这里的内核是forlinx 的FORLINX_linux-3.0.1.tar.gz内核,把这个文件准备好(拷贝到 linux os 的forlinx文件夹下面),这个文件不小117M,用xftp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAv2a0.html" rel="bookmark" class="title">通过ANT生成MANIFEST&period;MF中的Class-Path属性</a>
					<div>
						原文地址:http://reason2003.iteye.com/blog/1627353 之前做一个项目,主程序打包成一个jar文件,因为用到了很多第三方的lib包,所以直接通过java命令运行ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRNXQM.html" rel="bookmark" class="title">前缀转后缀（表达式）</a>
					<div>
						问题描述: 前缀表达式转成后缀表达式,示例: * + 4 2 + 3 6 =&gt; 4 2 + 3 6 + * 思路(树): 1. 从左往右扫描串 2. 遇到操作符则递归构造树节点,当前操作符是根节 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEeVr3.html" rel="bookmark" class="title">&lbrack;ACM&rsqb; FZU 1686 神龙的难题 （DLX 重复覆盖）</a>
					<div>
						Problem 1686 神龙的难题 Accept: 444    Submit: 1365 Time Limit: 1000 mSec    Memory Limit : 32768 KB  Pro ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
